const renderers = [];

export function prettify (code, raw = false) {
	if (!raw) {
		for (const {check, render} of renderers) {
			if (check(code)) return render(code, prettify);
		}
	}

	if (typeof code === "number") {
		return code.toString();
	}

	if (code[0] === 0) {
		return "(λ" + prettify(code[1], raw) + ")";
	} else {
		return "(" + prettify(code[0], raw) + " " + prettify(code[1], raw) + ")";
	}
}

export function add_special_renderer (def) {
	if (!def.hasOwnProperty("check")) return;
	if (!def.hasOwnProperty("render")) return;

	renderers.push(def);
}
